/*
 * ##################################################### Start MainSite Addon #####################################################
 */

MainSite.prototype.getKimFriendlyName = function() {
  return 'ise smart connect KNX'
}

MainSite.prototype.addProductTopNavMenuItems = function() {
  //  this.pages['LoginPage'] = new LoginPage();

  this.menu.system.target.insertAsFirst(new MenuItem('change_settings', 'NetworkSettingsPage'));
  this.pages['NetworkSettingsPage'] = new NetworkSettingsPage();
  this.pages['NetworkSettingsPage'].ipSettingsFormEnabled = true;
  this.pages['NetworkSettingsPage'].ntpSettingsFormEnabled = true;
  //
  //  this.menu.add(new MenuItem('user', new Menu(new MenuItem('change_password', 'ChangePasswordPage'))));
  //  this.pages['ChangePasswordPage'] = new ChangePasswordPage();
  //
  //  this.menu.user.target.add(new MenuItem('logout', 'LogoutPage'));
  //  this.pages['LogoutPage'] = new LogoutPage();
}

/*
 * ##################################################### End MainSite Addon #####################################################
 */

/*
* ##################################################### Start StatusPage Addon #####################################################
*/

var tv1OnOffStatusCO = 2;
var tv1ErrorIndicationCO = 90;
var tv1LastErrorCO = 91;

var tv2OnOffStatusCO = 102;
var tv2ErrorIndicationCO = 190;
var tv2LastErrorCO = 191;

var ipTv1 = undefined;			// IP #1
var ipTv2 = undefined;			// IP #2
var hostnameTv1 = undefined;	// Text #15
var hostnameTv2 = undefined;	// Text #16
var useHostnameTv1 = undefined;	// Number #1 Bit 31
var useHostnameTv2 = undefined;	// Number #1 Bit 30

StatusPage.prototype.appendDOMFragmentCOInfosTo = function(parentElement) {
  var span = document.createElement('span');
  span.setAttribute('hidden', '');
  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        span.removeAttribute('hidden');
      } else {
        span.setAttribute('hidden', '');
      }
    }
  );
  
  parentElement.appendChild(span);
  parentElement = span;
  
  var tv1Info = document.createElement('b');
  tv1Info.appendChild(document.createTextNode(i18n.translate('tv1_information') + ': ' + i18n.translate('device_not_projected')));
  tv1Info.appendChild(document.createElement('br'));
  parentElement.appendChild(tv1Info)
  
  var spanTV1 = document.createElement('span');
  spanTV1.setAttribute('hidden', '');
  parentElement.appendChild(spanTV1);
  
  var tv2Info = document.createElement('b');
  tv2Info.appendChild(document.createTextNode(i18n.translate('tv2_information') + ': ' + i18n.translate('device_not_projected')));
  parentElement.appendChild(document.createElement('br'));
  parentElement.appendChild(tv2Info)

  var spanTV2 = document.createElement('span');
  spanTV2.setAttribute('hidden', '');
  parentElement.appendChild(spanTV2);
   
  thisClass.dataBindings.push(
  function() {
    if (mainSite.appState) {
      if (mainSite.appState.state == 'Running' && ipTv1 == undefined && hostnameTv1 == undefined ) {
        IscWebService("getTextParameter", {number:15}, function(response) {
          if (response.data != undefined){
            hostnameTv1 = "";
            if(response.data.value) {
              hostnameTv1 = response.data.value;
              while (tv1Info.hasChildNodes()) {
                tv1Info.removeChild(tv1Info.childNodes[0]);
              }
              if (hostnameTv1 != "") {
                tv1Info.appendChild(document.createTextNode(i18n.translate('tv1_information') + ': ' + hostnameTv1), tv1Info.childNodes[0]);
                tv1Info.appendChild(document.createElement('br'));
                spanTV1.removeAttribute('hidden');
              } else {
                tv1Info.appendChild(document.createTextNode(i18n.translate('tv1_information') + ': ' + i18n.translate('device_not_projected')));
                tv1Info.appendChild(document.createElement('br'));
              }
            }
          }
          if (hostnameTv1 == ""){
            IscWebService("getIpParameter", {number:1}, function(response) {
              if (response.data != undefined && response.data.value) {
                ipTv1 = response.data.value;
                while (tv1Info.hasChildNodes()) {
                  tv1Info.removeChild(tv1Info.childNodes[0]);
                }
                if (ipTv1 != "0.0.0.0") {
                  tv1Info.appendChild(document.createTextNode(i18n.translate('tv1_information') + ': ' + ipTv1), tv1Info.childNodes[0]);
                  tv1Info.appendChild(document.createElement('br'));
                  spanTV1.removeAttribute('hidden');
                } else {
                  tv1Info.appendChild(document.createTextNode(i18n.translate('tv1_information') + ': ' + i18n.translate('device_not_projected')));
                  tv1Info.appendChild(document.createElement('br'));
                }
              }
            }, false);
          }
        }, false);
      }
      if (mainSite.appState.state == 'Running' && ipTv2 == undefined && hostnameTv2 == undefined) {
        IscWebService("getTextParameter", {number:16}, function(response) {
          if (response.data != undefined){
            hostnameTv2 = "";
            if (response.data.value) {
              hostnameTv2 = response.data.value;
              while (tv2Info.hasChildNodes()) {
                tv2Info.removeChild(tv2Info.childNodes[0]);
              }
              if (hostnameTv2 != "") {
                tv2Info.appendChild(document.createTextNode(i18n.translate('tv2_information') + ': ' + hostnameTv2), tv2Info.childNodes[0]);
                spanTV2.removeAttribute('hidden');
              } else {
                tv2Info.appendChild(document.createTextNode(i18n.translate('tv2_information') + ': ' + i18n.translate('device_not_projected')));
              }
            }
          }
          if (hostnameTv2 == ""){
            IscWebService("getIpParameter", {number:2}, function(response) {
              if (response.data != undefined && response.data.value) {
                ipTv2 = response.data.value;
                while (tv2Info.hasChildNodes()) {
                  tv2Info.removeChild(tv2Info.childNodes[0]);
                }
                if (ipTv2 != "0.0.0.0") {
                  tv2Info.appendChild(document.createTextNode(i18n.translate('tv2_information') + ': ' + ipTv2), tv2Info.childNodes[0]);
                  //tv2Info.appendChild(document.createElement('br'));
                  spanTV2.removeAttribute('hidden');
                } else {
                  tv2Info.appendChild(document.createTextNode(i18n.translate('tv2_information') + ': ' + i18n.translate('device_not_projected')));
                  //tv2Info.appendChild(document.createElement('br'));
                }
              }
            }, false);
          }
        }, false);
      }
      if (mainSite.appState.state != 'Running') {
        ipTv1 = undefined;
        ipTv2 = undefined;
        hostnameTv1 = undefined;
        hostnameTv2 = undefined;
        spanTV1.setAttribute('hidden', '');
        spanTV2.setAttribute('hidden', '');
        while (tv1Info.hasChildNodes()) {
          tv1Info.removeChild(tv1Info.childNodes[0]);
        }
        while (tv2Info.hasChildNodes()) {
          tv2Info.removeChild(tv2Info.childNodes[0]);
        }
      }
    } else {
      ipTv1 = undefined;
      ipTv2 = undefined;
      hostnameTv1 = undefined;
      hostnameTv2 = undefined;
      while (tv1Info.hasChildNodes()) {
        tv1Info.removeChild(tv1Info.childNodes[0]);
      }
      while (tv2Info.hasChildNodes()) {
        tv2Info.removeChild(tv2Info.childNodes[0]);
      }
    }
  });


  //add translation elements  ('co_state_' + CONumber) to translation files
  this.appendDOMFragmentKimCoInfoTo(spanTV1, tv1OnOffStatusCO);
  spanTV1.appendChild(document.createElement('br'));
  this.appendDOMFragmentKimCoInfoTo(spanTV1, tv1ErrorIndicationCO);
  spanTV1.appendChild(document.createElement('br'));
  this.appendDOMFragmentKimCoInfoTo(spanTV1, tv1LastErrorCO);
  spanTV1.appendChild(document.createElement('br'));

  spanTV2.appendChild(document.createElement('br'));
  this.appendDOMFragmentKimCoInfoTo(spanTV2, tv2OnOffStatusCO);
  spanTV2.appendChild(document.createElement('br'));
  this.appendDOMFragmentKimCoInfoTo(spanTV2, tv2ErrorIndicationCO);
  spanTV2.appendChild(document.createElement('br'));
  this.appendDOMFragmentKimCoInfoTo(spanTV2, tv2LastErrorCO);

  spanTV2.appendChild(document.createElement('br'));
  var thisClass = this;

}

StatusPage.prototype.prepareAppInfo = function(divAppInfomation) {
  headerAppInformation = document.createElement('h3');
  headerAppInformation.setAttribute('class', 'h3');
  headerAppInformation.appendChild(document.createTextNode(i18n.translate('application_information')));
  divAppInfomation.appendChild(headerAppInformation);

  var fragmentAppState = document.createElement('span');
  fragmentAppState.setAttribute('hidden', '');
  divAppInfomation.appendChild(fragmentAppState);
  this.appendDOMFragmentAppStateTo(fragmentAppState);

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        fragmentAppState.removeAttribute('hidden');
      } else {
        fragmentAppState.setAttribute('hidden', '');
      }
    }
  );

  // Enable this for CO Infos.
  this.appendDOMFragmentCOInfosTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));
}
//Example for default handling of Boolean COs and specific String COs handling
StatusPage.prototype.updateCO = function(span, textNode, currentCO) {
	
 /*
  * Fernseher on/off CO 2 / 102
  * Fehler vorhanden (aktiv) CO 90 / 190
  * Letzter Fehlertext CO 91 / 191
  */
	
  switch (currentCO.id) {
    case tv1LastErrorCO:
	case tv2LastErrorCO:
           textNode.nodeValue = i18n.translate(currentCO.value);
      break;
	case tv1ErrorIndicationCO:
	case tv2ErrorIndicationCO:
           if (currentCO.value == '1') {
             span.setAttribute('class', 'text--error bold');
             textNode.nodeValue = i18n.translate('active');
           } else if (currentCO.value == '0') {
             span.setAttribute('class', 'text--muted');
             textNode.nodeValue = i18n.translate('inactive');
           }
	  break;
	case tv1OnOffStatusCO:
	case tv2OnOffStatusCO:
           if (currentCO.value == '1') {
             span.setAttribute('class', 'text--success');
             textNode.nodeValue = i18n.translate('on').toLowerCase();
           } else if (currentCO.value == '0') {
             span.setAttribute('class', 'text--success');
             textNode.nodeValue = i18n.translate('off').toLowerCase();
           }
	  break;
    default:
      //     if (currentCO.value == '1') {
      //       span.setAttribute('class', 'text--success');
      //       textNode.nodeValue = i18n.translate('True');
      //     } else if (currentCO.value == '0') {
      //       span.setAttribute('class', 'text--error');
      //       textNode.nodeValue = i18n.translate('False');
      //     }
      break;
  }
}
/*
 * ##################################################### End StatusPage Addon #####################################################
 */